function exe_root_1(obj) {
	//テスト
	//document.getElementById("interAd").style.display = "block";
	//document.getElementById("interLink").style.display = "block";
	//名前
	obj.cegSessionKey = getCegSessionKey();
	obj.cegUserName   = getCegUserName();
	obj.name_txt.text = "@" + obj.cegUserName;
	//サウンド
	obj.soundFlg = getCegSoundFlg(CEG_AID);
	if(obj.soundFlg == FLG_ON) {
		obj.btn_sound_mc.gotoAndStop(0);
	} else {
		obj.btn_sound_mc.gotoAndStop(1);
	}
	obj.audios = loadSound();
	obj.tokenmiss = 0;
	//ハイスコア
	obj.recordScore = displayRecord(obj.record_score_mc);
	//顔
	obj.chara_mc.gotoAndStop(FACE_NORMAL);
	//ボタン
	firstRegistListener(obj);
	formatTopDisplay(obj);
	//ストップ
	obj.stop();
}

//トップ画面の初期化(ロード時)
function formatTopDisplay(obj) {
	//テキストエリアを無効化
	document.getElementById("commentArea").style.display = "none";
	document.getElementById("commentTextArea").value = "";
	//インステ広告を非表示
	//document.getElementById("interAd").style.display = "none";
	//document.getElementById("interLink").style.display = "none";
	//表示
	if(obj.soundFlg == FLG_ON) {
		obj.btn_sound_mc.gotoAndStop(0);
	} else {
		obj.btn_sound_mc.gotoAndStop(1);
	}
	//タイマーカウンター
	obj.timeCounter = 0;
	obj.remaindTimeCounter = 0;
	obj.remaindTime = REMAIND_TIME;
	obj.warningTimeFlg = false;
	//ゲーム変数
	obj.questFlg = false;//出題中フラグ
	obj.questions = [];//出題番号
	obj.progressWordStopFlg = false;//テキスト流している最中かどうか
	obj.score = 0;//スコア
	obj.nowQuestionNumber = 0;//現在出題している番号
	obj.nowHint = "";//現在のヒント
	obj.nowHintProgress = 0;//現在のヒントの流れている文字数
	obj.usePanelFlgs = [null, false, false, false, false, false, false, false, false, false, false];//使用済かどうか
	obj.panelCharas = [null, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];//パネルがどの文字になっているか
	obj.answers = [];//現在の解答
	obj.timeupFlg = false;
	obj.hintCounter = 0;//ヒントカウンター
	obj.heartCounter = 0;//ハートカウンター
	obj.heartFlg = false;//現在ハートでているか？
	obj.heartPlace = 0;//ハートの場所1-10
	obj.starCounter = 0;//スターカウンター
	obj.starFlg = false;//現在スターでているか？
	obj.starPlace = 0;//スターの場所1-10
	obj.closeEyeFlg = false;
	obj.endingFlg = false;
	obj.rankingFlg = false;
	obj.totalRank = 0;
	obj.dailyRank = 0;

	obj.token = "";
	obj.pl = "";
	
	obj.connectCount = 0;
	obj.kashaSoundFlg = false;
}

//ゲーム画面の初期化(startボタン押下時処理)
function formatGameDisplay(obj) {
	//テキストエリアを有効化
	document.getElementById("commentArea").style.display = "block";
	//タイマー
	obj.time_number_mc.visible = false;
	obj.time_number_mc2.visible = false;
	obj.setGameDisplayId = setTimeout(kickRemaindTime, 100, obj);	
	//カーソルフォーマット
	formatCursor(obj);
	//リスナー
	addListernerPanel(obj);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(PANEL_REGEXP.test(event.target.parent.name)) {
	        	judgeWord(obj, event.target.parent.name.substr(1));
	        } else {
	        }
	        break;
	    }
	};
	//音楽
	playsound(obj, 0);
	if(obj.playCount) {
		obj.playCount ++;
	} else {
		obj.playCount = 1;
	}
	
}

//ゲーム画面初期化（タイムアウト後）
function kickRemaindTime(obj) {
	clearTimeout(obj.setGameDisplayId);
	//タイマー
	obj.time_number_mc.visible = true;
	setRemaindTime(obj.time_number_mc, obj.remaindTime);
	//問題出題
	newQuestions(obj);
	//パネルフォーマット
	formatPanels(obj);
	//スコア
	setNumberMc(obj.score_mc, obj.score);
}

//サウンドon/off切り替え
function changeSoundFlg(obj) {
    if(obj.soundFlg == FLG_ON) {
    	obj.soundFlg = FLG_OFF;
    	obj.btn_sound_mc.gotoAndStop(1);
    } else {
    	obj.soundFlg = FLG_ON;
		obj.btn_sound_mc.gotoAndStop(0);
    }
    setCegSoundFlg(CEG_AID, obj.soundFlg);
}

//ユーザ名変更からの戻り
function responseChangeCegUserName(userName, obj) {
	alert("名前を変更しました");
	obj.cegUserName = userName;
	obj.name_txt.text = "@" + obj.cegUserName;
}
function errorChangeCegUserName(obj) {
	alert("名前の変更に失敗しました。通信状況をご確認ください。");
}

//時間を進める
function progressRemaindTime(obj) {
	if(obj.timeupFlg) return;
	obj.remaindTimeCounter ++;
	if(obj.remaindTimeCounter >= MAX_TIME_COUNTER) {
		obj.remaindTimeCounter = 0;
		obj.remaindTime --;
		
		if(obj.remaindTime <= 0) {
			//finishFormat(obj);
			timeup(obj);
		}
		displayRemaindTime(obj);
	}
}

function displayRemaindTime(obj) {
	if(obj.remaindTime <= 10 && !obj.warningTimeFlg) {
		obj.time_number_mc2.visible = true;
		obj.time_number_mc.visible = false;
		obj.warningTimeFlg = true;
	}
	if(obj.warningTimeFlg) {
		setRemaindTime(obj.time_number_mc2, obj.remaindTime);
	} else {
		setRemaindTime(obj.time_number_mc, obj.remaindTime);
	}
}

//パネルヒント対応
function progressPanelHint(obj) {
	if(obj.timeupFlg) return;
	obj.hintCounter++;
	if(obj.hintCounter >= MAX_HINT_COUNTER) {
		obj.hintCounter = 0;
		var progress = obj.answers.length;//0
		var answer = WORDS[obj.nowQuestionNumber][1];
		for(var i=1; i<=10; i++) {
			if(answer.charAt(progress, 1) == CHARS[obj.panelCharas[i]]) {
				eval("obj.p" + i + ".panel_hint_mc").visible = true;
				break;
			}
		}
	}
}

//タイムアップ
function timeup(obj) {
	//音消し
	stopsound(obj, 0);//
	obj.timeupFlg = true;
	clearInterval(obj.intervalId);
	//パネルのリスナー解除
	removeListenerPanel(obj);
	//パネル初期化
	formatPanels(obj);
	formatCursor(obj);
	//アラート
	obj.timeup_mc.gotoAndPlay(1);
	//セリフ1
	document.getElementById("commentTextArea").value = "しゅ〜〜りょ〜〜〜";
	//スコア表示
	obj.last_score_mc.gotoAndStop(1);
	setNumberMc(obj.last_score_mc.score_mc, obj.score);
	//ハイスコア更新
	if(obj.score > obj.recordScore) {
		localStorage.setItem("pachequiz_recordsocre", obj.score);
		obj.last_score_mc.new_record_mc.visible = true;
	} else {
		obj.last_score_mc.new_record_mc.visible = false;
	}
	//スコア送信
	ajaxSendPoint(obj, obj.score, obj.cegSessionKey, obj.token, obj.pl);
	//
	
	var r = getRandomInt(5);
	console.log("r=" + r);
	if(r==2) {
		displayInterAd();
	} else if(r==3) {
		displayInterLink();
	}
}

function kickTimeup(obj) {
	//セリフ
	var level = getLevelByScore(obj.score);//0-4
	if(obj.cegUserName == "ゲスト" && obj.rankingFlg) {
        changeFace(obj, FACE_SMILE);
        document.getElementById("commentTextArea").value = "ランクインおめでとう。トップページから名前を変更してみましょう。";
    } else {
    	var r = getRandomInt(TIMEUP_SERIF[level].length);
		document.getElementById("commentTextArea").value = TIMEUP_SERIF[level][r];
    }
}

//出題
function newQuestions(obj) {
	if(obj.questFlg) return;
	if(obj.timeupFlg) return;
	while(true) {
		var q = getRandomInt(WORDS.length);
		if (obj.questions.indexOf(q) == -1 || obj.questions.length >= WORDS.length) {
			obj.nowQuestionNumber = q;
			obj.pl += "00"+q+"00";
			break;
		}
	}
	obj.nowHint = WORDS[obj.nowQuestionNumber][0];
	obj.nowHintProgress = 0;
	obj.questions.push(obj.nowQuestionNumber);
	obj.questFlg = true;
	obj.progressWordStopFlg = false;
	obj.answers = [];

	//カーソル処理
	var answer = WORDS[obj.nowQuestionNumber][1];
	for(var i=1; i<=10; i++) {
		if(i==1) {
			eval("obj.cs" + i).gotoAndStop(1);
		} else if(answer.length >= i) {
			eval("obj.cs" + i).gotoAndStop(0);
		} else {
			eval("obj.cs" + i).gotoAndStop(CURSOL_FORMAT_FRAME);
			eval("obj.cs" + i + ".c").gotoAndStop(0);
		}	
	}
}

//カーソルをフォーマットします
function formatCursor(obj) {
	for(var i=1; i<=10; i++) {
		eval("obj.cs" + i).gotoAndStop(CURSOL_FORMAT_FRAME);
		eval("obj.cs" + i + ".c").gotoAndStop(PANEL_FORMAT_FRAME);
	}
}

//ワードヒントを流す
function progressWord(obj) {
	if(!obj.questFlg || obj.progressWordStopFlg) return;
	if((obj.nowHintProgress-1)*5 > obj.nowHint.lengthB()) {
		obj.progressWordStopFlg = true;
		readyPanel(obj);
		return;
	}
	obj.nowHintProgress ++;
	document.getElementById("commentTextArea").value = obj.nowHint.substrB(0, obj.nowHintProgress*5);
}

//パネルを用意する
function readyPanel(obj) {
	for(var i=1; i<=10; i++) {
		obj.usePanelFlgs[i] = false;
	}
	formatPanels(obj);
	var answer = WORDS[obj.nowQuestionNumber][1];
	for(var j=1; j<=answer.length; j++) {
		var k=0;
		while(k++ < 100) {
			var r = getRandomInt(10)+1;//1-10
			if(obj.panelCharas[r] == 0) {
				var charaKey = CHARS.indexOf(answer.charAt(j-1, 1));
				obj.panelCharas[r] = charaKey;
				eval("obj.p" + r + ".c").gotoAndStop(charaKey);
				break;
			}
		}
	}
}

//１文字正解判定
function judgeWord(obj, panelNumber) {
	if(!obj.progressWordStopFlg) return;
	if(obj.usePanelFlgs[panelNumber]) return;
	obj.pl += panelNumber;
	var answer = WORDS[obj.nowQuestionNumber][1];//正解文字
	var progress = obj.answers.length;//0
	if(answer.charAt(progress, 1) == CHARS[obj.panelCharas[panelNumber]]) {
		//正解
		
		obj.answers.push(obj.panelCharas[panelNumber]);
		eval("obj.p" + panelNumber + ".panel_cover_mc").visible = true;
		eval("obj.p" + panelNumber + ".panel_hint_mc").visible = false;
		obj.usePanelFlgs[panelNumber] = true;

		obj.score += CHAR_POINT;
		setNumberMc(obj.score_mc, obj.score);

		//カーソルを確定させる
		eval("obj.cs" + (progress+1)).gotoAndStop(2);
		var charaKey = CHARS.indexOf(answer.charAt(progress, 1));
		eval("obj.cs" + (progress+1) + ".c").gotoAndStop(charaKey);

		obj.hintCounter = 0;

		if(obj.answers.length == answer.length) {
			//正解
			playsound(obj, 2);//
			document.getElementById("commentTextArea").value = "正解！";
			//演出
			obj.alert_maru_mc.visible = true;
			setTimeout(unDisplayJudgeAlert, 1000, obj);
			changeFace(obj, FACE_SMILE);
			//ポイント
			obj.score += BASE_POINT;
			setNumberMc(obj.score_mc, obj.score);

			//次の問題キック
			obj.correctTimerId = setTimeout(kickCorrect, 500, obj);
		} else {
			eval("obj.cs" + (progress+2)).gotoAndStop(1);
		}


	} else {
		//ハートか？
		if(panelNumber == obj.heartPlace && obj.panelCharas[panelNumber] != 0) {
			playsound(obj, 4);//ピロン
			//eval("obj.p" + panelNumber + ".panel_cover_mc").visible = true;
			//eval("obj.p" + panelNumber + ".panel_hint_mc").visible = false;
			eval("obj.p" + panelNumber + ".heart_mc").visible = false;
			//obj.panelCharas[panelNumber] = 0;
			unDisplayHeart(obj);
			obj.remaindTime += LIFE_UP;
			displayRemaindTime(obj);
		} else if(panelNumber == obj.starPlace && obj.panelCharas[panelNumber] != 0) {
			playsound(obj, 4);//ピロン
			//eval("obj.p" + panelNumber + ".panel_cover_mc").visible = true;
			//eval("obj.p" + panelNumber + ".panel_hint_mc").visible = false;
			eval("obj.p" + panelNumber + ".star_mc").visible = false;
			//obj.panelCharas[panelNumber] = 0;
			unDisplayStar(obj);
			obj.score += POINT_UP;
			setNumberMc(obj.score_mc, obj.score);
		} else {
			//不正解
			playsound(obj, 1);//
			obj.score -= MINUS_POINT;
			if(obj.score<0) obj.score = 0;
			setNumberMc(obj.score_mc, obj.score);
			//演出
			obj.alert_batu_mc.visible = true;
			setTimeout(unDisplayJudgeAlert, 1000, obj);
			changeFace(obj, FACE_ANGRY);
			//演出終了キック
			obj.correctTimerId = setTimeout(kickUnCorrect, 500, obj);	
		}

		
	}
}

//正解して次の問題へ
function kickCorrect(obj) {
	clearTimeout(obj.correctTimerId);
	//変数初期化
	obj.heartPlace = 0;
	obj.starPlace = 0;
	obj.questFlg = false;
	obj.progressWordStopFlg = false;
	formatPanels(obj);
	newQuestions(obj);
}

//不正解
function kickUnCorrect(obj) {

}

//ハート出すか？
function displayHeart(obj) {
	obj.heartCounter++;
	if(obj.heartCounter>MAX_HEART_COUNTER) {
		obj.heartCounter = 0;

		//検索位置を決める(0-9+1 -> 1-10)
		var r = getRandomInt(PANEL_COUNT)+1;
		for(var i=0; i<PANEL_COUNT; i++) {
			//i= 0~9
			var s = r+i;//1〜19
			if(s > PANEL_COUNT) s = s-PANEL_COUNT;
			if(obj.panelCharas[s]==0) {
				obj.panelCharas[s] = true;
				obj.heartPlace = s;
				eval("obj.p" + obj.heartPlace + ".heart_mc").visible = true;
				obj.unDisplayHeartId = setTimeout(unDisplayHeart, 1000, obj);
				break;
			}
		}
		
	}
}

//☆を出すか？
function displayStar(obj) {
	obj.starCounter++;
	if(obj.starCounter>MAX_STAR_COUNTER) {
		obj.starCounter = 0;

		//検索位置を決める
		var r = getRandomInt(PANEL_COUNT)+1;
		for(var i=0; i<PANEL_COUNT; i++) {
			var s = r+i;
			if(s > PANEL_COUNT) s = s-PANEL_COUNT;
			if(obj.panelCharas[s]==0) {
				obj.panelCharas[s] = true;
				obj.starPlace = s;
				eval("obj.p" + obj.starPlace + ".star_mc").visible = true;
				obj.unDisplayStarId = setTimeout(unDisplayStar, 1000, obj);
				break;
			}
		}
		
	}
}

function unDisplayHeart(obj) {
	if(obj.heartPlace==0) return;
	eval("obj.p" + obj.heartPlace + ".heart_mc").visible = false;
	//obj.panelCharas[obj.heartPlace] = 0;
	obj.heartPlace = 0;
}

function unDisplayStar(obj) {
	if(obj.starPlace==0) return;
	eval("obj.p" + obj.starPlace + ".star_mc").visible = false;
	//obj.panelCharas[obj.starPlace] = 0;
	obj.starPlace = 0;
}

function unDisplayJudgeAlert(obj) {
	obj.alert_batu_mc.visible = false;
	obj.alert_maru_mc.visible = false;
}

function changeFace(obj, faceId) {
	obj.closeEyeFlg = true;
	setTimeout(openEye, 1000, obj);
	obj.chara_mc.gotoAndStop(faceId);
}

function exeEye(obj) {
	if(obj.closeEyeFlg) return;
	var r = getRandomInt(30);
	if(r>=1) return;
	obj.closeEyeFlg = true;
	setTimeout(openEye, 100, obj);
	obj.chara_mc.gotoAndStop(FACE_CLOSE_EYE);
}

function openEye(obj) {
	obj.closeEyeFlg = false;
	obj.chara_mc.gotoAndStop(FACE_NORMAL);
}

function displayEndingButton(obj) {
	obj.last_buttons.gotoAndStop(3);
}

//インターステイシャルを表示
function displayInterAd(obj) {
	//document.getElementById('interInlineAd').src="interAd.html";
	//document.getElementById("interAd").style.display = "block";
}

//インターリンクを表示
function displayInterLink(obj) {
	//document.getElementById('interInlineLink').src="interLink.html";
	//document.getElementById("interLink").style.display = "block";
}
