function firstRegistListener(obj) {
	obj.btn_start_mc.addEventListener('click', obj, false);
	obj.btn_start_mc.addEventListener('touchstart', obj, false);
	obj.btn_change_name_mc.addEventListener('click', obj, false);
	obj.btn_change_name_mc.addEventListener('touchstart', obj, false);
	obj.btn_sound_mc.addEventListener('click', obj, false);
	obj.btn_sound_mc.addEventListener('touchstart', obj, false);
	obj.btn_ranking_mc.addEventListener('click', obj, false);
	obj.btn_ranking_mc.addEventListener('touchstart', obj, false);
	obj.dummy_mc.addEventListener('click', obj, false);
	obj.dummy_mc.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "btn_start_mc") {
	      		onStart(obj);
	        } else if(event.target.parent.name == "btn_change_name_mc") {
	        	var inputName = prompt("名前を入力してください", obj.cegUserName);
	        	if(inputName != undefined && inputName != null && inputName != "") {
	        		changeCegUserName(CEG_AID, obj.cegSessionKey, inputName, obj);
	        	}
	        } else if(event.target.parent.name == "btn_sound_mc") {
	        	changeSoundFlg(obj);
	        } else if(event.target.parent.name == "btn_ranking_mc") {
	        	location.href = "ranking.html";
	        } else if(event.target.parent.name == "btn_tweet_mc" && obj.gameFinishFlg) {
	        	onTweet(obj);
	        } else {
	        }
	        break;
	    }
	};
}

function onStart(obj) {
	//2フレームへ
	obj.gotoAndStop(2);
	obj.last_score_mc.gotoAndStop(0);
	obj.daily_ranking_mc.gotoAndStop(0);
	obj.total_ranking_mc.gotoAndStop(0);
	obj.last_buttons.gotoAndStop(0);
	obj.ending_mc.gotoAndStop(0);
	unDisplayJudgeAlert(obj);

	//ゲーム画面初期化
	formatGameDisplay(obj);

	//タイマー開始
	obj.intervalId = setInterval(onFrame, INTERVAL, obj);

	//データ
	//ajaxData(1, "start");

	//トークン取得
	kickGetToken(obj);
	//不要
	//obj.intervalTokenId = setInterval(kickGetToken, INTERVAL_TOKEN, obj);
}

//ゲーム中のframe
function onFrame(obj) {
	//テキストを回す
	progressWord(obj);

	//時間を進める
	progressRemaindTime(obj);

	//ヒント対応
	progressPanelHint(obj);

	//ハート対応
	displayHeart(obj);

	//スター対応
	displayStar(obj);

	//瞳対応
	exeEye(obj);

}

//最終ボタン
function addLastButtons(obj) {
	obj.last_buttons.btn_back_mc.addEventListener('click', obj, false);
	obj.last_buttons.btn_back_mc.addEventListener('touchstart', obj, false);
	obj.last_buttons.btn_prize_mc.addEventListener('click', obj, false);
	obj.last_buttons.btn_prize_mc.addEventListener('touchstart', obj, false);
	obj.last_buttons.btn_tweet_mc.addEventListener('click', obj, false);
	obj.last_buttons.btn_tweet_mc.addEventListener('touchstart', obj, false);
	obj.last_buttons.btn_reconnect_mc.addEventListener('click', obj, false);
	obj.last_buttons.btn_reconnect_mc.addEventListener('touchstart', obj, false);
	obj.last_buttons.btn_prize_mc.gotoAndStop(0);
	if(obj.score > BORDER_POINT) obj.last_buttons.btn_prize_mc.gotoAndStop(1);
	obj.dummy_mc2.addEventListener('click', obj, false);
	obj.dummy_mc2.addEventListener('touchstart', obj, false);
	obj.dummy_mc3.addEventListener('click', obj, false);
	obj.dummy_mc3.addEventListener('touchstart', obj, false);
	obj.handleEvent = function(event) {
		switch(event.type) {
	      case 'click':
	      case 'touchstart':
	      	if(event.target.parent.name == "btn_back_mc") {
	      		if(obj.endingFlg) {
	      			obj.endingFlg = false;
	      			obj.ending_mc.gotoAndStop(0);
	      			obj.last_buttons.gotoAndStop(1);
	      			var r = getRandomInt(3);
	      			document.getElementById("commentTextArea").value = PRIZE_SERIF[r];
	      			changeFace(obj, FACE_SMILE);
	      		} else {
	      			removeLastButtons(obj);
		      		obj.last_score_mc.gotoAndStop(0);
		      		obj.last_buttons.gotoAndStop(0);
		      		obj.gotoAndStop(1);
		      		firstRegistListener(obj);
		        	formatTopDisplay(obj);
	      		}
	      		
	        } else if(event.target.parent.name == "btn_prize_mc") {
	        	if(obj.score > BORDER_POINT) {
	        		document.getElementById("commentTextArea").value = "";
	        		obj.last_buttons.gotoAndStop(4);
	        		obj.endingFlg = true;
	        		obj.ending_mc.gotoAndPlay(1);
	        	}
	        } else if(event.target.parent.name == "btn_tweet_mc") {
	        	onTweet(obj);
	        } else if(event.target.parent.name == "btn_reconnect_mc") {
	        	removeLastButtons(obj);
	        	ajaxSendPoint(obj, obj.score, obj.cegSessionKey, obj.token, obj.pl);
	        } else {

	        }
	        break;
	    }
	};
	
}

function removeLastButtons(obj) {
	obj.last_buttons.btn_back_mc.removeEventListener('click', obj, false);
	obj.last_buttons.btn_back_mc.removeEventListener('touchstart', obj, false);
	obj.last_buttons.btn_prize_mc.removeEventListener('click', obj, false);
	obj.last_buttons.btn_prize_mc.removeEventListener('touchstart', obj, false);
	obj.last_buttons.btn_tweet_mc.removeEventListener('click', obj, false);
	obj.last_buttons.btn_tweet_mc.removeEventListener('touchstart', obj, false);
	obj.dummy_mc2.removeEventListener('click', obj, false);
	obj.dummy_mc2.removeEventListener('touchstart', obj, false);
	obj.dummy_mc3.removeEventListener('click', obj, false);
	obj.dummy_mc3.removeEventListener('touchstart', obj, false);
}

//ツイートボタン
function onTweet(obj) {
	var tweetStr = "";
	tweetStr += "https://twitter.com/intent/tweet?related=odm&source=tweetbutton&text=";
	tweetStr += "%23パチュリー様とえっちなお勉強しーましょ";
	tweetStr += "%20記録%20" + obj.score + "ポイント";
	if(obj.totalRank > 0) {
		tweetStr += "%20トータルランキング%20" + obj.totalRank + "位%20";
	}
	if(obj.dailyRank > 0) {
		tweetStr += "%20デイリーランキング%20" + obj.dailyRank + "位%20";
	}
	tweetStr += "%20https://printdora-s3-files.s3-ap-northeast-1.amazonaws.com/2/pache_quiz.html";
	
	open( tweetStr, "_blank" ) ;
	//window.location = tweetStr;
}

function closeAd() {
	document.getElementById("interAd").style.display = "none";
}

function closeLink() {
	document.getElementById("interLink").style.display = "none";
}