//maxを含まない
function getRandomInt(max) {
	return Math.floor(Math.random() * Math.floor(max));
}

String.prototype.lengthB = function() {
    var len = 0;
    for (var i = 0; i < this.length; i++) {
    if (this.charAt(i).isMultibyte()) {
    len += 2;
    } else {
    len += 1;
    }
    }
    return len;
}

String.prototype.substrB = function() {
    var fromByte = arguments[0];
    var retByte = arguments[1];

    // 開始位置の検索
    var len = 0;
    var i;
    for (i = 0; fromByte > len; i++) {
        if (this.charAt(i).isMultibyte()) {
            len += 2;
        } else {
            len += 1;
        }
    }
    var from = i;

    len = 0;
    var retLen = 0;
    while(retByte > len) {
        if (this.charAt(i).isMultibyte()) {
            len = len + 2;
        } else {
            len = len + 1;
        }
        retLen++;
        i++;
    }
    return this.substr(from, retLen);
}
String.prototype.isMultibyte = function() {
    var c = this.charCodeAt(0);
    // 半角の範囲
    // Unicode : 0x0 ～ 0x80, 0xf8f0, 0xff61 ～ 0xff9f, 0xf8f1 ～ 0xf8f3
    if ((c >= 0x0 && c <= 0x80) || (c == 0xf8f0) || (c >= 0xff61 && c <= 0xff9f) || (c >= 0xf8f1 && c <= 0xf8f3)) {
        return false;
    } else {
        return true;
    }
}

function getAdText() {
    /*
	if(navigator.userAgent.match(/(iPhone|iPad|iPod|Android)/i)) {
		//sp
		return AD2;
	} else {
		//pc
		return AD1;
	}
    */
}

function getInterAdText() {
    /*
    if(navigator.userAgent.match(/(iPhone|iPad|iPod|Android)/i)) {
        //sp
        return AD4;
    } else {
        //pc
        return AD3;
    } 
    */  
}

//サウンドを一旦読み込みます
function loadSound() {
    var audioTimes = new Array();
    var audios = new Array();
    for(var i=0; i<SOUND_FILE.length; i++) {
        var soundFileName = SOUND_FILE[i];
        audios[i] = new Audio();
        audios[i].src = "sound/" + soundFileName + ".mp3"; 
        audios[i].load();
        audios[i].filename = soundFileName;
        if(i==0) audios[i].loop = true;
    }
    return audios;
}

//記録の表示
function displayRecord(record_mc) {
    var recordScore = localStorage.getItem("pachequiz_recordsocre");
    if(recordScore == undefined || recordScore == null || recordScore==0) {
        setNumberMc(record_mc, 0);
    } else {
        setNumberMc(record_mc, recordScore);
    }
    return recordScore;
}

//残り時間表示
function setRemaindTime(numberMc, remaindTime) {
    setNumberMc3(numberMc, remaindTime);
}

//3桁
function setNumberMc3(numberMc, number) {
    if(number<0) number = 0;
    var d3 = Math.floor(number/100);
    var d2 = Math.floor((number - d3*100) / 10);
    var d1 = number - d3*100 - d2*10;

    if(d3 == 0) {
        numberMc.unit3.gotoAndStop(11);
    } else {
        numberMc.unit3.gotoAndStop(d3+1);
    }
    if(d2 == 0 && d3==0) {
        numberMc.unit2.gotoAndStop(11);
    } else {
        numberMc.unit2.gotoAndStop(d2+1);
    }
    numberMc.unit1.gotoAndStop(d1+1);
}

//6桁
function setNumberMc(numberMc, number) {
    if(number<0) number = 0;
    var d6 = Math.floor(number/100000);
    var d5 = Math.floor((number - d6*100000) / 10000);
    var d4 = Math.floor((number - d6*100000 - d5*10000) / 1000);
    var d3 = Math.floor((number - d6*100000 - d5*10000 - d4*1000) / 100);
    var d2 = Math.floor((number - d6*100000 - d5*10000 - d4*1000 - d3*100) / 10);
    var d1 = number - d6*100000 - d5*10000 - d4*1000 - d3*100 - d2*10;

    if(d6 == 0) {
        numberMc.unit6.gotoAndStop(11);
    } else {
        numberMc.unit6.gotoAndStop(d6+1);
    }
    if(d5 == 0 && d6==0) {
        numberMc.unit5.gotoAndStop(11);
    } else {
        numberMc.unit5.gotoAndStop(d5+1);
    }
    if(d4 == 0 && d5==0) {
        numberMc.unit4.gotoAndStop(11);
    } else {
        numberMc.unit4.gotoAndStop(d4+1);
    }
    if(d3 == 0 && d4==0) {
        numberMc.unit3.gotoAndStop(11);
    } else {
        numberMc.unit3.gotoAndStop(d3+1);
    }
    if(d2 == 0 && d3==0) {
        numberMc.unit2.gotoAndStop(11);
    } else {
        numberMc.unit2.gotoAndStop(d2+1);
    }
    numberMc.unit1.gotoAndStop(d1+1);
}

//レベルを取得します
function getLevelByScore(score) {
    if(score < 100) return 0;
    if(score < 250) return 1;
    if(score < 400) return 2;
    if(score < 500) return 3;
    return 4
}

//トークン取得
function kickGetToken(obj) {
    getCegToken(CEG_AID, obj.cegSessionKey, obj);
}

function responseGetCegToken(token, obj) {
    obj.token = token;
    obj.tokenmiss = 0;
}

function errorGetCegToken(obj) {
    obj.tokenmiss ++;
    if(obj.tokenmiss > 5) window.alert("通信のできる場所でプレイしてくださいね。");
}

//スコア送信
function ajaxSendPoint(obj, pt, sk, tk, pl) {
    //console.log(URL_SENDPOINT + "?aid="+CEG_AID+"&pt="+pt+"&sk="+sk);
    $.ajax(URL_SENDPOINT, {
        type: 'post',
        data: { "aid":CEG_AID , "pt": pt, "sk": sk, "tk":tk, "pl":pl },
        dataType: 'json',
        timeout: 1000,
      }
    )
    // 通信成功
    .done(function(res) {
        if(res["dailyRank"] != undefined) {
            obj.daily_ranking_mc.gotoAndStop(1);
            setNumberMc3(obj.daily_ranking_mc.rank_mc, res["dailyRank"]);
            obj.dailyRank = res["dailyRank"];
            obj.rankingFlg = true;
        }
        if(res["totalRank"] != undefined) {
            obj.total_ranking_mc.gotoAndStop(1);
            setNumberMc3(obj.total_ranking_mc.rank_mc, res["totalRank"]);
            obj.totalRank = res["totalRank"];
        }
        sendpointAfter(obj);
    })
    // 通信失敗(タイムアウトまたはサーバエラー)
    .fail(function(XMLHttpRequest, textStatus, errorThrown) {
        document.getElementById("commentTextArea").value = "通信失敗しました。通信のできる場所でプレイしてくださいね。";
        //再通信ボタン表示
        addLastButtons(obj);
        obj.last_buttons.gotoAndStop(2);
        displayInterAd(obj);
    });
}

function sendpointAfter(obj) {
    //タイムアップキック
    obj.timeupId = setTimeout(kickTimeup, 2000, obj);
    //ボタン表示
    obj.last_buttons.gotoAndStop(1);
    obj.addLastButtonId = setTimeout(addLastButtons, 500, obj);
    //トークンインターバル削除
    clearInterval(obj.intervalTokenId);

    //displayInterAd(obj);
}

//-----------------------------------------------------------------
//
//-----------------------------------------------------------------

//パネルリスナーを登録します
function addListernerPanel(obj) {
    obj.p1.addEventListener('click', obj, false);
    obj.p2.addEventListener('click', obj, false);
    obj.p3.addEventListener('click', obj, false);
    obj.p4.addEventListener('click', obj, false);
    obj.p5.addEventListener('click', obj, false);
    obj.p6.addEventListener('click', obj, false);
    obj.p7.addEventListener('click', obj, false);
    obj.p8.addEventListener('click', obj, false);
    obj.p9.addEventListener('click', obj, false);
    obj.p10.addEventListener('click', obj, false);

    obj.p1.addEventListener('touchstart', obj, false);
    obj.p2.addEventListener('touchstart', obj, false);
    obj.p3.addEventListener('touchstart', obj, false);
    obj.p4.addEventListener('touchstart', obj, false);
    obj.p5.addEventListener('touchstart', obj, false);
    obj.p6.addEventListener('touchstart', obj, false);
    obj.p7.addEventListener('touchstart', obj, false);
    obj.p8.addEventListener('touchstart', obj, false);
    obj.p9.addEventListener('touchstart', obj, false);
    obj.p10.addEventListener('touchstart', obj, false);
}

//パネルリスナーを解除します
function removeListenerPanel(obj) {
    obj.p1.removeEventListener('click', obj, false);
    obj.p2.removeEventListener('click', obj, false);
    obj.p3.removeEventListener('click', obj, false);
    obj.p4.removeEventListener('click', obj, false);
    obj.p5.removeEventListener('click', obj, false);
    obj.p6.removeEventListener('click', obj, false);
    obj.p7.removeEventListener('click', obj, false);
    obj.p8.removeEventListener('click', obj, false);
    obj.p9.removeEventListener('click', obj, false);
    obj.p10.removeEventListener('click', obj, false);

    obj.p1.removeEventListener('touchstart', obj, false);
    obj.p2.removeEventListener('touchstart', obj, false);
    obj.p3.removeEventListener('touchstart', obj, false);
    obj.p4.removeEventListener('touchstart', obj, false);
    obj.p5.removeEventListener('touchstart', obj, false);
    obj.p6.removeEventListener('touchstart', obj, false);
    obj.p7.removeEventListener('touchstart', obj, false);
    obj.p8.removeEventListener('touchstart', obj, false);
    obj.p9.removeEventListener('touchstart', obj, false);
    obj.p10.removeEventListener('touchstart', obj, false);
}

//パネルをフォーマットします
function formatPanels(obj) {
    obj.panelCharas = [null, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    obj.usePanelFlgs = [null, false, false, false, false, false, false, false, false, false, false];
    obj.p1.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p2.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p3.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p4.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p5.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p6.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p7.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p8.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p9.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p10.c.gotoAndStop(PANEL_FORMAT_FRAME);
    obj.p1.panel_cover_mc.visible = false;
    obj.p2.panel_cover_mc.visible = false;
    obj.p3.panel_cover_mc.visible = false;
    obj.p4.panel_cover_mc.visible = false;
    obj.p5.panel_cover_mc.visible = false;
    obj.p6.panel_cover_mc.visible = false;
    obj.p7.panel_cover_mc.visible = false;
    obj.p8.panel_cover_mc.visible = false;
    obj.p9.panel_cover_mc.visible = false;
    obj.p10.panel_cover_mc.visible = false;

    obj.p1.panel_hint_mc.visible = false;
    obj.p2.panel_hint_mc.visible = false;
    obj.p3.panel_hint_mc.visible = false;
    obj.p4.panel_hint_mc.visible = false;
    obj.p5.panel_hint_mc.visible = false;
    obj.p6.panel_hint_mc.visible = false;
    obj.p7.panel_hint_mc.visible = false;
    obj.p8.panel_hint_mc.visible = false;
    obj.p9.panel_hint_mc.visible = false;
    obj.p10.panel_hint_mc.visible = false;

    obj.p1.heart_mc.visible = false;
    obj.p2.heart_mc.visible = false;
    obj.p3.heart_mc.visible = false;
    obj.p4.heart_mc.visible = false;
    obj.p5.heart_mc.visible = false;
    obj.p6.heart_mc.visible = false;
    obj.p7.heart_mc.visible = false;
    obj.p8.heart_mc.visible = false;
    obj.p9.heart_mc.visible = false;
    obj.p10.heart_mc.visible = false;

    obj.p1.star_mc.visible = false;
    obj.p2.star_mc.visible = false;
    obj.p3.star_mc.visible = false;
    obj.p4.star_mc.visible = false;
    obj.p5.star_mc.visible = false;
    obj.p6.star_mc.visible = false;
    obj.p7.star_mc.visible = false;
    obj.p8.star_mc.visible = false;
    obj.p9.star_mc.visible = false;
    obj.p10.star_mc.visible = false;

    
}

//音を出します
function playsound(obj, soundKey) {
    if(obj.soundFlg != FLG_ON) return;
    if(soundKey==0) {
        obj.audios[soundKey].volume = 0.4;
    }
    obj.audios[soundKey].play();
}

function stopsound(obj, soundKey) {
    obj.audios[soundKey].pause() ;
    obj.audios[soundKey].currentTime = 0 ;
}


